/* wptUtil.cpp - Helper functions
 *	Copyright (C) 2005 Timo Schulz
 *
 * This file is part of WinPT.
 *
 * WinPT is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2 
 * of the License, or (at your option) any later version.
 *  
 * WinPT is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with WinPT; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>

/* code taken from glibc-2.2.1/sysdeps/generic/strsep.c */
extern "C" char*
strsep (char **stringp, const char *delim)
{
    char *begin, *end;
    begin = *stringp;

    if (begin == NULL)
        return NULL;

    /* A frequent case is when the delimiter string contains only one
       character.  Here we don't need to call the expensive `strpbrk'
       function and instead work using `strchr'.  */
    if (delim[0] == '\0' || delim[1] == '\0') {
        char ch = delim[0];
        if (ch == '\0')
            end = NULL;
        else {
            if (*begin == ch)
                end = begin;                         
            else if (*begin == '\0')
                end = NULL;
            else
                end = strchr (begin + 1, ch);
        }  
    }
    else /* Find the end of the token.  */
        end = strpbrk (begin, delim);
    if ( end ){
        /* Terminate the token and set *STRINGP past NUL character.  */
        *end++ = '\0';
        *stringp = end;
    }
    else
        /* No more delimiters; this is the last token.  */
        *stringp = NULL;

    return begin;
}


/* Like strstr but this version is case in-sentensive. */
extern "C" const char *
stristr (const char *buf, const char *sub)
{
    const char *t, *s ;
    size_t n;
    size_t buflen = strlen (buf);

    for( t=buf, n=buflen, s=sub ; n ; t++, n-- ) {
	if( toupper(*t) == toupper(*s) ) {
	    for( buf=t++, buflen = n--, s++;
		 n && toupper(*t) == toupper(*s); t++, s++, n-- )
		;
	    if( !*s )
		return buf;
	    t = buf; n = buflen; s = sub ;
	}
    }
    return NULL ;
}

